#include <windows.h>
#include <stdio.h>
#include <topic.cpp>
#include <discipline.cpp>
//#include <screen.cpp>

#define WINDOW_NAME "AskMe 2.0"
#define BASE_PATH "Base\\"
#define MASK "*.txt"
#define STAT_STR_SIZE 48
#define TITLE_SIZE 1024
#define DSCPLN_NUMBER 64
#define TOPICS_NUMBER 128
#define Q_NUMBER 1024
#define VENTRY_NUMBER 64
#define LEFT_MAX (VENTRY_NUMBER/2-1)
#define LEFT_START 0
#define RIGHT_START VENTRY_NUMBER/2

#define ID_MENUABOUT 10
#define ID_MENUINFO 11
#define ID_MENUHOTKEYS 12
#define ID_MENUDISCIPLINE 20
#define ID_TOPIC 100
#define ID_OWNEDOK 200
#define ID_MAINOK 300
#define ID_VARIANTSTART 1000
#define ID_NUM 10000

#define Y_START 10
#define MENU_HEIGHT 60
#define TOPIC_WIDTH 250
#define TOPIC_HEIGHT 60
#define TOPIC_COLUMNS 3
#define VAR_HEIGHT 20
#define OKBUTTON_HEIGHT 30
#define WINDOWTITLE_HEIGHT 30
#define SPACER 15

class SingleVisualEntry
{
public:
	SingleVisualEntry();
	int qNumber;
	RECT task;
	RECT variants;
	HWND hVariant[VAR_NUMBER];
	HWND hOK;
	bool visible;
};

class Screen
{
public:
	Screen();
	void WM_PaintTask(HDC hDC);
	bool PlaceQuestion(int ToInsert, bool bReset);
	void InsertPosition(int nPosition);
	void HideAll();
	void RemoveInvisible();
	void Cleaner();
	HWND hWnd;
	RECT rMainWindow;
	int tmAveCharWidth;
	SingleVisualEntry Entry[VENTRY_NUMBER];
	int CurrentPosition;
};

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg, WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK OwnedProc(HWND hwnd, UINT Message, WPARAM wparam,LPARAM lparam);

void Init();
bool CreateMenuItem(HMENU hMenu, char* str, UINT uID, UINT wID, HMENU hSubMenu);

Screen OnScreen;
HINSTANCE hInst;
HFONT hCorrect,hMissing,hExcessive;
int QCount=-1;
int nCycle=1;

HWND hOwned;
int nID=ID_VARIANTSTART;
float fChar_test;
TopicClass Topic_test;
DisciplineClass Discipline;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int iCmdShow)
    {
    MSG msg;
    char ToSearch[PATH_SIZE];
    HMENU hMainMenu;
    HMENU hDscplnMenu;
    HMENU hHelpMenu;

    hInst=hInstance;
    Init();
    sprintf(ToSearch, "%s%s", BASE_PATH, MASK);
    Discipline.LoadDisciplines(ToSearch);

    hMainMenu = CreateMenu();
    hDscplnMenu = CreatePopupMenu();
    hHelpMenu = CreatePopupMenu();
    for (int i=0;i<=Discipline.DCount_ext;i++)
    {
	CreateMenuItem(hDscplnMenu, Discipline.Dscpln[i].title, 0, ID_MENUDISCIPLINE+i, NULL);
    }
    CreateMenuItem(hHelpMenu, "О программе", 1, ID_MENUABOUT, NULL);
    CreateMenuItem(hHelpMenu, "Горячие клавиши", 1, ID_MENUHOTKEYS, NULL);
    CreateMenuItem(hHelpMenu, "База данных", 1, ID_MENUINFO, NULL);
    CreateMenuItem(hMainMenu, "Дисциплины", 0, 0, hDscplnMenu);
    CreateMenuItem(hMainMenu, "Помощь", 1, 0, hHelpMenu);

    OnScreen.hWnd = CreateWindowEx
	(0,
	"MainWClass",
	WINDOW_NAME,
	WS_OVERLAPPEDWINDOW,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	(HWND) NULL,
	(HMENU) hMainMenu,
	hInstance,
	NULL);
    ShowWindow(OnScreen.hWnd,SW_MAXIMIZE);
    UpdateWindow(OnScreen.hWnd);

    TEXTMETRIC tmTM;
    GetClientRect(OnScreen.hWnd,&OnScreen.rMainWindow);
    HDC hDC=GetDC(OnScreen.hWnd);
    GetTextMetrics(hDC,&tmTM);
    ReleaseDC(OnScreen.hWnd,hDC);
    OnScreen.tmAveCharWidth=tmTM.tmAveCharWidth;

    fChar_test=OnScreen.rMainWindow.right/2;
    fChar_test=fChar_test/OnScreen.tmAveCharWidth;
//test
//char ct[3];
//sprintf(ct,"%d",Topic_test.length);
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
    ACCEL acc[VAR_NUMBER+2];
    acc[0].key='1';
    for(int i=0;i<VAR_NUMBER;i++)
    {
	acc[i].cmd = ID_NUM+i;
	acc[i].fVirt = (BYTE)NULL;
	acc[i].key=acc[0].key+i;
    }
    acc[VAR_NUMBER].cmd = ID_MAINOK;
    acc[VAR_NUMBER].fVirt = (BYTE)NULL;
    acc[VAR_NUMBER].key = (char)13;

    acc[VAR_NUMBER+1].cmd = ID_MAINOK;
    acc[VAR_NUMBER+1].fVirt = (BYTE)NULL;
    acc[VAR_NUMBER+1].key = (char)32;

    HACCEL hAccel = CreateAcceleratorTable((LPACCEL)acc, VAR_NUMBER+2);

while(GetMessage(&msg,NULL,0,0))
    {
	if(!(hAccel && TranslateAccelerator(OnScreen.hWnd, hAccel, &msg)))
	{
	TranslateMessage(&msg);
	DispatchMessage(&msg);
	}
    }
    DestroyAcceleratorTable(hAccel);
    return msg.wParam;
    }

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
static int QCurrent=0;
static bool bFirst=TRUE;

switch(msg)
{
case WM_PAINT:
{
	HDC hDC;
	PAINTSTRUCT ps;
	hDC=BeginPaint(hWnd,&ps);
	OnScreen.WM_PaintTask(hDC);
	EndPaint(hWnd,&ps);
}
break;

case WM_COMMAND:
{
    for(int i=0;i<=DSCPLN_NUMBER;i++)
    {
	if((LOWORD(wParam)==ID_MENUDISCIPLINE+i)&&(Discipline.Dscpln[i].loaded))
	{
	Discipline.UnloadTopics();
	Discipline.LoadTopics(Discipline.Dscpln[i]);
	Discipline.DrawChooser(hInst, OnScreen.hWnd, hOwned, OnScreen.rMainWindow.bottom, OnScreen.rMainWindow.right, Discipline.Dscpln[i].path);
	}
    }

for(int i=0;i<VAR_NUMBER;i++)
{
	if((LOWORD(wParam)==ID_NUM+i)&&(bFirst))
	{
	int nIDComponent=Topic_test.GetIDComponent(QCurrent);
	for(int j=0;j<VAR_NUMBER;j++)
	{
		if((Topic_test.Get(QCurrent)->variant[j].loaded)&&(i==j))
		{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+j);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
		}
	}
	}
}

if(!bFirst)
{
int nIDComponent=Topic_test.GetIDComponent(QCurrent);
for(int i=0;i<VAR_NUMBER;i++)
{
	if(LOWORD(wParam)==(ID_VARIANTSTART+nIDComponent+i))
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
	}
}
}

if(LOWORD(wParam)==ID_MENUABOUT)
{
char s[]="Программа для подготовки к тестированию \"AskMe 2.0\".\nДомашняя страница: http://mmaketchup.narod.ru/additional.htm\nПрограмма распространяется по лицензии GPL\nПожелания и предложения напрявляйте на e-mail: mmaketchup@mail.ru.\n\nАвтор - Ketchup.\nСентябрь 2006.";
MessageBox(OnScreen.hWnd,s,"О программе",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if(LOWORD(wParam)==ID_MENUHOTKEYS)
{
char s[]="Для выбора ответа используйте клавиши 1-7 на дополнительной (включите NumLock) или основной клавиатуре\nНажать кнопку \"OK\" можно пробелом или \"Enter\"";
MessageBox(OnScreen.hWnd,s,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if(LOWORD(wParam)==ID_MENUINFO)
{
char s[]="Формат базы:\nКаждый вопрос состоит из задания и вариантов ответа. На задание и варианты отводится по 1 строчке. Перед каждым вариантом стоит символ табуляции: (char)9\nКаждая дисциплина расположена в отдельной директории.\nОписание содержимого директории находится в файле \"Base\\x.txt\", где x - порядковый номер дисциплины\nВ файле-описании первая строчка отведена под название дисциплины. Далее идут строчки описания следующего формата: символ табуляции, затем название темы, далее в кавычках относительный путь к файлу с вопросами темы\nКодировка всех файлов: Windows-1251";
MessageBox(OnScreen.hWnd,s,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if (LOWORD(wParam)==ID_MAINOK)
{
static bool bOK=TRUE;
int nIDComponent=Topic_test.GetIDComponent(QCurrent);
//bOK=TRUE;
	for(int i=0;i<VAR_NUMBER;i++)
	{
	if(Topic_test.Get(QCurrent)->variant[i].loaded)
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		if(bFirst)
		{
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if((res == BST_CHECKED)&&(Topic_test.Get(QCurrent)->variant[i].correct))
			{SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hCorrect, 1);}
		if((res == BST_CHECKED)&&(!Topic_test.Get(QCurrent)->variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hExcessive, 1);}
		if((res == BST_UNCHECKED)&&(Topic_test.Get(QCurrent)->variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hMissing, 1);}
		}
		else EnableWindow(hwndCheck,0);
	}
	}
	if((bOK)&&(bFirst)) {Topic_test.Get(QCurrent)->completed=TRUE;}
	if(bFirst) {
Topic_test.GetStat(nCycle,0,OnScreen.hWnd);
	}
	if(!bFirst)
	{
		bOK=TRUE;
QCurrent=Topic_test.GetNextQuestion(QCurrent+1);
		if(QCurrent==-1)
			{
nID=ID_VARIANTSTART-1;
			Topic_test.GetStat(nCycle,1,OnScreen.hWnd);
			nCycle++;
			OnScreen.HideAll();
			OnScreen.RemoveInvisible();
			SetWindowText(hWnd,WINDOW_NAME);
QCurrent=Topic_test.GetNextQuestion(0);
			if(QCurrent==-1)
				{
				MessageBox(NULL,"Game over","Game over",MB_OK);
				nCycle=1;
				QCurrent=-1;
				OnScreen.HideAll();
				OnScreen.RemoveInvisible();
				SetWindowText(hWnd,WINDOW_NAME);
//Topic_test.UnloadQuestions();
//				UnloadQuestions();
//				UnloadTopics();
Discipline.UnloadTopics();
				}
			}
		OnScreen.PlaceQuestion(QCurrent,0);
	}
	bFirst=!bFirst;
}
return -1;
}

case (WM_USER):
{
	OnScreen.HideAll();
	OnScreen.RemoveInvisible();
	OnScreen.Cleaner();
	QCurrent=0;
	bFirst=TRUE;
	SetWindowText(hWnd,WINDOW_NAME);
	OnScreen.PlaceQuestion(QCurrent,1);
}
break;

case WM_DESTROY:
PostQuitMessage(0);
break;

default:
return DefWindowProc(hWnd,msg,wParam,lParam);
}

return 0;
}

LRESULT CALLBACK OwnedProc (HWND hwnd, UINT Message, WPARAM wparam, LPARAM lparam)
{
switch (Message)
{

case WM_CREATE:
{
	EnableWindow(OnScreen.hWnd,0);
	EnableWindow(hwnd,1);
}
break;

case WM_COMMAND:
{
if(LOWORD(wparam)==ID_OWNEDOK)
{
bool bChosen=FALSE;
//MessageBox(OnScreen.hWnd,"test","Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
for(int i=0;i<TOPICS_NUMBER;i++)
{
	if (Discipline.Topic[i].loaded)
	{
	HWND hwndCheck = GetDlgItem(hwnd, i+ID_TOPIC);
	LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
	if(res==BST_CHECKED)
	    {
	    Topic_test.UnloadQuestions();
	    Topic_test.LoadQuestions(Discipline.Topic[i].path);
    	    bChosen=TRUE;
//test
//char ct[3];
//sprintf(ct,"%d",i);
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
    	    }
	}
}

if(bChosen) PostMessage(OnScreen.hWnd,WM_USER,0,0);
DestroyWindow(hwnd);
}
return -1;
}
break;

case WM_DESTROY:
{
	EnableWindow(OnScreen.hWnd,1);
	BringWindowToTop(OnScreen.hWnd);
	return 0;
}
break;

default:
	return DefWindowProc(hwnd,Message,wparam,lparam);
}
}

void Init()
{
WNDCLASSEX wc;
WNDCLASS w;
hCorrect=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hMissing=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	1,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hExcessive=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	400,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	1,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);

wc.cbSize=sizeof(wc);
wc.cbClsExtra=0;
wc.cbWndExtra=0;
wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;
wc.hCursor=LoadCursor(0,IDC_ARROW);
wc.hIcon=LoadIcon(hInst,IDI_APPLICATION);
wc.hIconSm=LoadIcon(hInst,IDI_APPLICATION);
wc.hInstance=hInst;
wc.lpfnWndProc=WndProc;
wc.lpszClassName="MainWClass";
wc.lpszMenuName=NULL;
wc.style=CS_HREDRAW | CS_VREDRAW;
RegisterClassEx(&wc);

memset(&w,0,sizeof(WNDCLASS));
w.lpfnWndProc = OwnedProc;
w.hInstance = hInst;
w.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
w.lpszClassName = "OwnedWClass";
w.hCursor=LoadCursor(NULL,IDC_CROSS); 
RegisterClass(&w);
}

bool CreateMenuItem
	(
	HMENU hMenu,
	char* str,
	UINT uID,
	UINT wID,
	HMENU hSubMenu
	)
    {
    MENUITEMINFO mi;
    mi.cbSize = sizeof(MENUITEMINFO);
    mi.fMask = MIIM_STATE|MIIM_TYPE|MIIM_SUBMENU|MIIM_ID;
    mi.fType = MFT_STRING;
    mi.fState = MFS_ENABLED;
    mi.dwTypeData = str;
    mi.cch = sizeof(str);
    mi.wID = wID;
    mi.hSubMenu = hSubMenu;
    return InsertMenuItem(hMenu, uID, FALSE, &mi);
    }

SingleVisualEntry::SingleVisualEntry()
    {
	for(int i=0;i<VAR_NUMBER;i++) hVariant[i]=NULL;
	hOK=NULL;
	qNumber=-1;
	task.left=0;
	task.right=0;
	task.top=0;
	task.bottom=0;
	variants.left=0;
	variants.right=0;
	variants.top=0;
	variants.bottom=0;
	visible=FALSE;
    }

Screen::Screen()
    {
	CurrentPosition=-1;
    }

void Screen::WM_PaintTask(HDC hDC)
    {
    SetBkMode(hDC,TRANSPARENT);
    for(int i=0;i<VENTRY_NUMBER;i++)
    {
    if(Entry[i].visible)
    DrawText(
	hDC,
	Topic_test.Get(Entry[i].qNumber)->task,
	strlen(Topic_test.Get(Entry[i].qNumber)->task),
	&Entry[i].task,
	DT_WORDBREAK);
    }
    }

bool Screen::PlaceQuestion(int ToInsert, bool bReset)
    {
    if(bReset) nID=ID_VARIANTSTART-1;

    RECT tmp;
    int nTaskHeight,nVariantsHeight,nVarCount=0,nIDComponent=0;
    HDC hDC;
    int nCoefficient=1;
    float fCoefficient,fChar;

    if(ToInsert==-1) return 0;

    tmp.left=0;
    tmp.right=rMainWindow.right/2;
    tmp.top=0;
    tmp.bottom=SPACER;

    hDC=GetDC(hWnd);
    DrawText(hDC, Topic_test.Get(ToInsert)->task, strlen(Topic_test.Get(ToInsert)->task), &tmp, DT_CALCRECT|DT_WORDBREAK);
    ReleaseDC(hWnd,hDC);

    nTaskHeight=tmp.bottom-tmp.top;
    nTaskHeight+=SPACER;

    nVariantsHeight=0;
    for(int i=0;i<VAR_NUMBER;i++)
        {
        if(Topic_test.Get(ToInsert)->variant[i].loaded) 
        {nVariantsHeight+=Topic_test.Get(ToInsert)->variant[i].GetCoefficient(fChar_test)*VAR_HEIGHT;}
        }

    CurrentPosition++;
    if(CurrentPosition==VENTRY_NUMBER) CurrentPosition=0;

    if(CurrentPosition!=0)
    {
    if(
	(Entry[CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)
	>(rMainWindow.bottom-Y_START))
	{if((CurrentPosition<=LEFT_MAX)|(CurrentPosition==RIGHT_START))
		CurrentPosition=RIGHT_START;
	else CurrentPosition=LEFT_START;}
    }

    if(CurrentPosition!=0)
    {
    if((Entry[CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)<Entry[CurrentPosition].task.top)
	{InsertPosition(CurrentPosition);}
    }
    Entry[CurrentPosition].visible=FALSE;
    RemoveInvisible();

    if((CurrentPosition==LEFT_START)|(CurrentPosition==RIGHT_START)) Entry[CurrentPosition].task.top=Y_START;
    else Entry[CurrentPosition].task.top=Entry[CurrentPosition-1].variants.bottom;

    Entry[CurrentPosition].task.bottom=Entry[CurrentPosition].task.top+nTaskHeight;
    Entry[CurrentPosition].variants.top=Entry[CurrentPosition].task.bottom;
    Entry[CurrentPosition].variants.bottom=Entry[CurrentPosition].variants.top+nVariantsHeight;

    if(CurrentPosition<=LEFT_MAX)
    {
        Entry[CurrentPosition].task.left=Entry[CurrentPosition].variants.left=SPACER;
        Entry[CurrentPosition].task.right=Entry[CurrentPosition].variants.right=rMainWindow.right/2;
    }
    else
    {
        Entry[CurrentPosition].task.left=Entry[CurrentPosition].variants.left=SPACER+rMainWindow.right/2;
        Entry[CurrentPosition].task.right=Entry[CurrentPosition].variants.right=rMainWindow.right;
    }

    Entry[CurrentPosition].visible=1;
    Entry[CurrentPosition].qNumber=ToInsert;

    for(int i=1;i<VENTRY_NUMBER/2;i++)
    {
	if(CurrentPosition!=(VENTRY_NUMBER-i))
	{
	if
	(
		((CurrentPosition<=LEFT_MAX)&&(CurrentPosition+i)<=LEFT_MAX)|
		((CurrentPosition>=RIGHT_START)&&(CurrentPosition+i)>=RIGHT_START)
	)
	{
	if((Entry[CurrentPosition].variants.bottom+OKBUTTON_HEIGHT)>Entry[CurrentPosition+i].task.top)
		Entry[CurrentPosition+i].visible=FALSE;
	}
	}
    }
    RemoveInvisible();

    hDC=GetDC(hWnd);
    SetBkMode(hDC,TRANSPARENT);
    DrawText
	(hDC,
	Topic_test.Get(ToInsert)->task,
	strlen(Topic_test.Get(ToInsert)->task),
	&Entry[CurrentPosition].task,
	DT_WORDBREAK);
    ReleaseDC(hWnd,hDC);

    for(int i=0;i<VAR_NUMBER;i++)
    {
	if(Topic_test.Get(Entry[CurrentPosition].qNumber)->variant[i].loaded)
	{
		if(Topic_test.Get(Entry[CurrentPosition].qNumber)->showed!=0)
		{
		nIDComponent=Topic_test.GetIDComponent(Entry[CurrentPosition].qNumber);
		nID=ID_VARIANTSTART-1+nIDComponent+nVarCount;
		}
	nID++;
	Entry[CurrentPosition].hVariant[i]=
		CreateWindow
		("button",
		Topic_test.Get(Entry[CurrentPosition].qNumber)->variant[i].text,
		WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX|BS_MULTILINE,
		Entry[CurrentPosition].variants.left,
		Entry[CurrentPosition].variants.top+
		VAR_HEIGHT*Topic_test.Get(Entry[CurrentPosition].qNumber)->GetSumCoefficient(i,fChar_test),
		Entry[CurrentPosition].variants.right-Entry[CurrentPosition].variants.left,
		VAR_HEIGHT*Topic_test.Get(Entry[CurrentPosition].qNumber)->variant[i].GetCoefficient(fChar_test),
		hWnd,
		(HMENU)nID,
		hInst,
		NULL);
	nVarCount++;
//test
//char ct[3];
//sprintf(ct,"%d;%d;%d",nID,nIDComponent,Entry[CurrentPosition].qNumber);
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
//sprintf(ct,"%d;%d;%d;(%d)",ToInsert,nIDComponent,Entry[CurrentPosition].qNumber,GetIDComponent(Entry[CurrentPosition].qNumber));
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
	}
    }
    Entry[CurrentPosition].hOK=CreateWindow(
	"button",
	"OK",
	WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
	Entry[CurrentPosition].variants.left,
	Entry[CurrentPosition].variants.top+
	VAR_HEIGHT*Topic_test.Get(Entry[CurrentPosition].qNumber)->GetSumCoefficient(nVarCount,fChar_test),
	rMainWindow.right/2-2*SPACER,
	OKBUTTON_HEIGHT,
	hWnd,
	(HMENU)ID_MAINOK,
	hInst,
	NULL);
    Topic_test.Get(Entry[CurrentPosition].qNumber)->showed++;
//test
//char ct[3];
//sprintf(ct,"%d",Question[Entry[CurrentPosition].qNumber].showed);
//SetWindowText(hWnd,ct);
    return 1;
    }

void Screen::InsertPosition(int nPosition)
    {
    int nStart;
    if(nPosition<LEFT_MAX) nStart=LEFT_MAX;
    else if(nPosition>RIGHT_START) nStart=VENTRY_NUMBER-1;
    else nStart=0;
    for(int i=nStart;i>nPosition;i--)
    {
	Entry[i].qNumber=Entry[i-1].qNumber;
	Entry[i].task=Entry[i-1].task;
	Entry[i].variants=Entry[i-1].variants;
	Entry[i].visible=Entry[i-1].visible;
	for(int j=0;j<VAR_NUMBER;j++)
	{
		Entry[i].hVariant[j]=Entry[i-1].hVariant[j];
	}
	Entry[i].hOK=Entry[i-1].hOK;
    }
	for(int j=0;j<VAR_NUMBER;j++) {Entry[nPosition].hVariant[j]=NULL;}
	Entry[nPosition].hOK=NULL;
    }

void Screen::HideAll()
    {
    for(int i=0;i<VENTRY_NUMBER;i++) {Entry[i].visible=FALSE;}
    CurrentPosition=-1;
    }

void Screen::RemoveInvisible()
    {
    for(int i=0;i<VENTRY_NUMBER;i++)
    {
	if((!Entry[i].visible)&(Entry[i].qNumber!=-1))
	{
	InvalidateRect(hWnd, &Entry[i].task,1);
	for(int j=0;j<VAR_NUMBER;j++)
	{
		if(Topic_test.Get(Entry[i].qNumber)->variant[j].loaded)
		{
		if(Entry[i].hVariant[j]!=NULL) {DestroyWindow(Entry[i].hVariant[j]);Entry[i].hVariant[j]=NULL;}
		}
	}
	}
	if(i!=CurrentPosition)
	{
	if(Entry[i].hOK!=NULL) {DestroyWindow(Entry[i].hOK);Entry[i].hOK=NULL;}
	}
	UpdateWindow(hWnd);
    }
    }

void Screen::Cleaner()
    {
    HWND hWndFind;
    do
    {
        hWndFind=GetWindow(hWnd,GW_CHILD);
        if(hWndFind!=NULL) DestroyWindow(hWndFind);
    }
    while(hWndFind!=NULL);
    }
